<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ page import="org.wso2.carbon.registry.ui.relations.clients.RelationServiceClient" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.registry.ui.relations.beans.xsd.DependenciesBean" %>

<script type="text/javascript" src="../registry_common/js/registry_validation.js"></script>
<script type="text/javascript" src="../registry_common/js/registry_common.js"></script>
<script type="text/javascript" src="js/prototype.js"></script>
<script type="text/javascript" src="js/relations.js"></script>
<%
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    RelationServiceClient client = new RelationServiceClient(cookie, config, session);
    DependenciesBean bean;
    try {
        bean = client.getDependencies(request);
    } catch (Exception e) {
        response.setStatus(500);
        CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
        session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
    <jsp:include page="../admin/error.jsp?<%=e.getMessage()%>"/>
<%
        return;
    }
%>
<fmt:bundle basename="org.wso2.carbon.registry.ui.relations.i18n.Resources">
    <div class="box1-head" style="height:auto;">
        <table cellspacing="0" cellpadding="0" border="0" style="width: 100%;">
            <tbody>
                <tr>
                    <td valign="top">
                        <h2 class="sub-headding-associations"><fmt:message key="associations"/></h2>
                    </td>
                    <td align="right" valign="top" class="expanIconCell">


                        <a onclick="showAssociations()">
                            <img src="images/icon-expanded.gif" border="0" align="top"
                                 id="associationsIconExpanded" style="display:none;"/>
                            <img src="images/icon-minimized.gif" border="0" align="top"
                                 id="associationsIconMinimized"/>
                        </a>

                    </td>

                </tr>
            </tbody>
        </table>
    </div>
    <div class="box1-mid-fill" id="associationsMinimized"></div>
    <div class="box1-mid" id="associationsExpanded" style="display:none">
        <% if (bean.getLoggedIn() && !bean.getVersionView() && bean.getPutAllowed()) { %>
        <div class="icon-link-ouside">
            <a class="icon-link" style="background-image:url(../admin/images/add.gif);"
               onclick="javascript:showHideCommon('associationsAddDiv');expandIfNot('associations');if($('associationsAddDiv').style.display!='none')document.forms.assoForm.type.focus()">Add
                <fmt:message key="association"/>
            </a>
        </div>
        <% } %>
        <div id="associationsSum"></div>
        <div id="associationsAddDiv" style="display:none;">
            <form onsubmit="return addAssociation('assoForm');" name="assoForm">
                <input type="hidden" name="resourcePath" id="resourcePath"
                       value="<%=bean.getPathWithVersion()%>"/>
                <table cellpadding="0" cellspacing="0" border="0" class="styledLeft">
                    <thead>
                        <tr>
                            <th colspan="2"><fmt:message key="add.new.association"/></th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <td valign="top"><fmt:message key="type"/> <span class="required">*</span></td>
                            <td><input type="text" name="type" id="type"
                                       style="width:130px;margin-bottom:5px;"/>
                            </td>
                        </tr>
                        <tr>
                            <td valign="top"><fmt:message key="path"/> <span class="required">*</span></td>
                            <td><input type="text" id="associationPaths" name="associationPaths"/>
                                <input type="button" class="button"
                                       value=".."  title="<fmt:message key="resource.tree"/>" 
                                       onclick="showResourceTree('associationPaths');"/>
                            </td>
                        </tr>
                        <tr>

                            <td colspan="2" class="buttonRow"><input type="button" class="button"
                                                                     value="<fmt:message key="add"/>"
                                                                     onclick="addAssociation('assoForm');"/><input
                                    style="margin-left:5px;" type="button"
                                    class="button" value="<fmt:message key="cancel"/>"
                                    onclick="showHideCommon('associationsAddDiv');"/>
                            </td>
                        </tr>
                    </tbody>
                </table>

            </form>
        </div>


        <% String url = "../relations/association-list-ajaxprocessor.jsp?type=asso&path=" + request.getParameter("path");%>
        <div id="associationsDiv">

            <jsp:include page="<%=url%>"/>
        </div>
    </div>
</fmt:bundle>