<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>

<%@ page import="org.wso2.carbon.registry.ui.relations.clients.RelationServiceClient" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.registry.ui.relations.beans.xsd.DependenciesBean" %>

<script type="text/javascript" src="../registry_common/js/registry_validation.js"></script>
<script type="text/javascript" src="../registry_common/js/registry_common.js"></script>
<script type="text/javascript" src="js/prototype.js"></script>
<script type="text/javascript" src="js/relations.js"></script>
<%
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    RelationServiceClient client = new RelationServiceClient(cookie, config, session);
    DependenciesBean bean;
    try {
        bean = client.getDependencies(request);
    } catch (Exception e) {
        response.setStatus(500);
        CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
        session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
    <jsp:include page="../admin/error.jsp?<%=e.getMessage()%>"/>
<%
        return;
    }
%>
<fmt:bundle basename="org.wso2.carbon.registry.ui.relations.i18n.Resources">

    <div class="box1-head" style="height:auto;">
        <table cellspacing="0" cellpadding="0" border="0" style="width: 100%;">
            <tbody>
                <tr>
                    <td valign="top">
                        <h2 class="sub-headding-dependencies"><fmt:message key="dependencies"/></h2>
                    </td>
                    <td align="right" valign="top" class="expanIconCell">


                        <a onclick="showDependencies()">
                            <img src="images/icon-expanded.gif" border="0" align="top"
                                 id="dependenciesIconExpanded" style="display:none;"/>
                            <img src="images/icon-minimized.gif" border="0" align="top"
                                 id="dependenciesIconMinimized"/>
                        </a>

                    </td>
                </tr>
            </tbody>
        </table>
    </div>
   <div class="box1-mid-fill" id="dependenciesMinimized"></div>
    <div class="box1-mid" style="height:auto;display:none" id="dependenciesExpanded">
        <% if (bean.getLoggedIn() && !bean.getVersionView() && bean.getPutAllowed()) { %>
        <div class="icon-link-ouside">
            <a class="icon-link" style="background-image:url(../admin/images/add.gif);"
               onclick="javascript:showHideCommon('dependenciesAddDiv');if($('dependenciesAddDiv').style.display!='none')$('depPaths').focus();">Add
                <fmt:message key="dependency"/></a>
        </div>
        <% } %>
        <div id="dependenciesSum"></div>

        <div id="dependencyReason" class="validationError" style="display: none;"></div>
        <div id="dependenciesAddDiv" style="display:none;">
            <form onsubmit="return addAssociation('depForm');" name="depForm">
                <input type="hidden" id="resourcePath" name="resourcePath"
                       value="<%=bean.getPathWithVersion()%>"/>
                <input type="hidden" name="type" value="depends"/>
                <table cellpadding="0" border="0" class="styledLeft">
                    <thead>
                        <tr>
                            <th colspan="2"><fmt:message key="add.dependency"/></th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr>
                            <td valign="top"><fmt:message key="path"/> <span class="required">*</span>
                            </td>
                            <td><input type="text" name="associationPaths" id="depPaths"/>
                                <input type="button" class="button" title="<fmt:message key="resource.tree"/>" value=".."
                                       onclick="showResourceTree('depPaths');"/>
                            </td>
                        </tr>
                        <tr>
                            <td colspan="2" class="buttonRow">
                                <input type="button" class="button"
                                       value="<fmt:message key="add"/>"
                                       onclick="addAssociation('depForm');"/>
                                <input style="margin-left:5px;" type="button"
                                       class="button" value="<fmt:message key="cancel"/>"
                                       onclick="showHideCommon('dependenciesAddDiv');"/>
                            </td>
                        </tr>
                    </tbody>
                </table>

            </form>
        </div>


        <% String url = "../relations/association-list-ajaxprocessor.jsp?type=depends&path=" + request.getParameter("path"); %>
        <div id="dependenciesDiv">

            <jsp:include page="<%=url%>"/>
        </div>
    </div>
</fmt:bundle>